/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

Alternatively, the contents of this file may be used under the
terms of the GNU General Public License Version 2 or later (the
"GPL"), in which case the provisions of the GPL are applicable 
instead of those above. 

Copyright (C) 2003
Vasa Maximov
mcv@mozdev.org
vmaximov@strana.ru
*/

var PlugsPath = "";
var ReadOnlyCqr = "";
var delim = "";
var AllFiles = [];
var PlugExt = "";
var fname = "";
var fcnt = 0;
var slabel = "";

function loader(){
	PlugsPath = window.opener.top.PlugsDirBox.value;
	PlugExt = window.arguments[0];
	delim = window.opener.top.delim;
	window.setTimeout('LoadEmAll();', 0);
}

function LoadEmAll(){
try{
  window.sizeToContent();
  if (!PlugsPath) return;
  exploredir(PlugsPath);
  var cnt = 0;
  fcnt = AllFiles.length;
	var item = new window.opener.top.ProtoEntry();
	fcnt = AllFiles.length;
	setTimeout('LoadPlug();',0);
}catch(er){cqerr(er, "LoadEmAll sub")}
}

function LoadPlug(){
try{
  cnt = AllFiles.length;
  if (cnt){
    fname = AllFiles.pop();
    window.opener.top.repEntryHash._AddEntryObj(window.opener.top.ReadPluginData(fname), "");
    setTimeout('LoadPlug();', 0);
    progressBar(fcnt, cnt);
  }else{
    window.opener.top.initRepTree(window.opener.top.repEntryList, window.opener.top.repEntryHash)
    window.close()
  }
}catch(err){alert(err)}
}

function exploredir(start){
  var items = cqReadDir(start);
  items.QueryInterface(Components.interfaces.nsISimpleEnumerator);
  while (items.hasMoreElements()) {
    var i = items.getNext();
    i.QueryInterface(Components.interfaces.nsIFile);
    if (i.isDirectory()){
      exploredir(start+delim+i.leafName);
    }else{
      var fn = i.leafName;
      var fx = fn.substr(fn.length - 4, fn.length);
      if (fx == "."+PlugExt) AllFiles[AllFiles.length] = start+delim+i.leafName;
    }
  }
}


function cqReadDir(dirname) {
    var dir = Components.classes["@mozilla.org/file/local;1"].
               createInstance(Components.interfaces.nsILocalFile);
    dir.initWithPath(dirname);
    if (dir.isDirectory()) {
        return dir.directoryEntries;
    } else {
        cqerr(null, "Error reading directory:\n" + dirname);
    }
}

function progressBar(ftotal, fleft){
  percent = Math.round(100*((ftotal-fleft)/ftotal));
  if (percent < 100){
      document.getElementById('parserstatus').value = "Plugins left: "+fleft;
  } else {
      document.getElementById('parserstatus').value = "Done!";
  }

  if (percent >= 0) {
      document.getElementById('progress').mode = 'determined';
      document.getElementById("progress").value = percent
  }
  else {
      document.getElementById('progress').mode = 'undetermined';
  }
}